#include <stdio.h>
#include <stdlib.h>

/// zaglavlje funkcije
int min2broja(int a, int b) {
    /// tijelo funkcije
    int min;
    if (a < b) {
        min = a;
    }
    else {
        min = b;
    }
    return min;
}

/**
2. Napisati program koji iscrtava pravougaonik od zvjezdica
sa zadatim dužinama stranica. Ako su dužine stranica
a = 7 i b = 4, program treba da štampa sljedeće:

*******
*     *
*     *
*******

Možete pretpostaviti da će važiti a >= 3 i b >= 3.
*/

void stampa_reda(int a, int puni_red) {
    printf("*");
    int j;
    for (j = 0; j < a-2; j++) {
        if (puni_red == 1) {
            printf("*");
        }
        else {
            printf(" ");
        }
    }
    printf("*\n");
}

void stampa_pravougaonika(int a, int b) {
    stampa_reda(a, 1);
    int i;
    for (i = 0; i < b-2; i++) {
        stampa_reda(a, 0);
    }
    stampa_reda(a, 1);
}

/**
Goldbahova hipoteza kaže da se svaki parni broj veći od 2
može predstaviti (reprezentovati) kao zbir dva prosta broja.
Napisati program koji za svaki parni broj n iz opsega od
10 do 100 nalazi proste brojeve p i q takve da je n=p+q i
štampa dobijene rezultate. Primjeri:
10=3+7
12=5+7
...
50=3+47
...
98=19+79
100=3+97
Za svaki broj štampati tačno jednu Goldbahovu reprezentaciju
(nije dozvoljeno štampanje duplikata). Za brojeve za koje
postoji više opcija dozvoljeno je štampati bilo koju od njih.
*/

int prost(int x) {
    int ind = 1;
    int d = 2;
    while (d*d <= x) {
        if (x % d == 0) {
            ind = 0;
            break;
        }
        d++;
    }
    return ind;
}

void goldbahova_reprezantacija(int n) {
    int p;
    for (p = 3; p <= n-3; p += 2) {
        int q = n - p;
        if (prost(p) == 1 && prost(q) == 1) {
            printf("%d = %d + %d\n", n, p, q);
            break;
        }
    }
}

/**
Napisati program koji ucitava prirodan broj n i stampa
sljedecu "piramidu"(na slici je n=5):

1
1 2
1 2 3
1 2 3 4
1 2 3 4 5
1 2 3 4
1 2 3
1 2
1
*/

void piramida_brojeva(int n) {
    int i, j;
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= i; j++) {
            printf("%d ", j);
        }
        printf("\n");
    }
    for (i = n-1; i >= 1; i--) {
        for (j = 1; j <= i; j++) {
            printf("%d ", j);
        }
        printf("\n");
    }
}

int main()
{
    // vise poziva funkcije min2broja
    /*printf("%d\n", min2broja(15, 25));
    printf("%d\n", min2broja(10, 5));
    printf("%d\n", min2broja(1, 2));*/

    //int a, b;
    //scanf("%d %d", &a, &b);
    //stampa_pravougaonika(a, b);

    /*stampa_pravougaonika(5, 5);
    stampa_pravougaonika(8, 3);*/

    /// varijanta bez funkcija
    /*int n;
    for (n = 10; n <= 100; n += 2) {
        int p;
        int d;

        for (p = 3; p <= n-3; p += 2) {
            int q = n - p;

            int ind_p = 1;
            d = 2;
            while (d*d <= p) {
                if (p % d == 0) {
                    ind_p = 0;
                    break;
                }
                d++;
            }

            int ind_q = 1;
            d = 2;
            while (d*d <= q) {
                if (q % d == 0) {
                    ind_q = 0;
                    break;
                }
                d++;
            }

            if (ind_p == 1 && ind_q == 1) {
                printf("%d = %d + %d\n", n, p, q);
                break;
            }
        }
    }*/

    /// varijanta sa pomocnim funkcijama
    /*int n;
    for (n = 10; n <= 100; n += 2) {
        // goldbahova_reprezantacija(n);
        int p;
        for (p = 3; p <= n-3; p += 2) {
            int q = n - p;
            if (prost(p) == 1 && prost(q) == 1) {
                printf("%d = %d + %d\n", n, p, q);
                break;
            }
        }
    }*/

    //piramida_brojeva(5);
    int n = 5;
    int i, j;
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= i; j++) {
            printf("%d ", j);
        }
        printf("\n");
    }
    for (i = n-1; i >= 1; i--) {
        for (j = 1; j <= i; j++) {
            printf("%d ", j);
        }
        printf("\n");
    }


    return 0;
}
